local L = Capitalist.Locale

function Capitalist:Debug(...)
	local format, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z = ...;
	self:Print(string.format("DBG "..format, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z))
end

local DebugStack = {}

function Capitalist:DebugEntry(...)
	local fn = ...;

	if (self.db and self.db.profile.debug.TraceFunctions) then
		table.insert(DebugStack, fn)
		self:Debug(">"..fn)
	end
end

function Capitalist:DebugExit(...)
	local fn, ret = ...;

	if (self.db and self.db.profile.debug.TraceFunctions) then
		self:Debug("<"..fn)
		table.remove(DebugStack)
	end

	return ret
end

function Capitalist:DebugOutputCallstack()
	if (self.db and self.db.profile.debug.TraceFunctions) then
		self:Print("Callstack:")
	end

	local indent = ""
	for i=1, #DebugStack do
		indent = indent.."  "
		self:Print(indent..DebugStack[i])
	end
end

function Capitalist:DebugMisc(...)
	local v = ...;

	if (self.db and self.db.profile.debug.TraceMisc) then
		self:Debug("%s", tostring(v))
	end
end
